#pragma semicolon 1

#include <sourcemod>
#include <vip>

#include "vip_skin_color/vars.sp"
#include "vip_skin_color/funstions.sp"
#include "vip_skin_color/reload.sp"
#include "vip_skin_color/menu.sp"

public Plugin:myinfo = 
{
	name	= "VIP [Skin Color]",
	author	= "wS",
	version = "1.0.4"
};

public OnPluginStart()
{
	for (new client = 1; client <= MaxClients; client++)
		DISABLE_COLOR(client);
	
	if (!(g_ItemID = VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT))) // g_ItemID нужен для проверки доступа когда копается в меню
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	
	LoadTranslations("vip_skin_color.phrases");
	VIP_HookEvent(VE_Spawn, OnClientSpawn);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (COLOR_ENABLED(client))
	{
		COLOR_TO_STRING(g_MyColor[client], ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (!bCallAfterAdminAction || (CURRENT_ACCESS == CURRENT_ACCESS_YES_GROUP && !ItemValue[0] && !COLOR_ENABLED(client)))
	{
		// Нужно взять значение из кэша.
		
		if (kv)
		{
			KvRewind(kv);
			
			decl String:sColorName[COLOR_NAME_LENGTH];
			KvGetString(kv, ITEM_NAME, sColorName, COLOR_NAME_LENGTH, "");
			
			if (sColorName[0] && (g_MyColorIndex[client] = FindStringInArray(g_hNameAr, sColorName)) > -1)
			{
				decl c[4];
				GetArrayArray(g_hColorAr, g_MyColorIndex[client], c, sizeof(c));
				UpdateClientColorAndNotify(client, c);
				return VGA_Continue; // Ок, взяли значение из кэша и успешно применили.
			}
		}
		
		return VGA_Paused; // Говорим "он отключил функцию, попробуй указать какое-то значение".
	}
	
	decl c[4];
	if (!GetColorFromString(ItemValue, c, sizeof(c)))
		c[0] = -1; // Цвет не указан или указан неверно
	
	if (!CURRENT_ACCESS)
	{
		// У игрока и его VIP группы (если он VIP) нет доступа к функции.
		// return VGA_Continue = дать доступ (функция появится в !vip меню) (это временный доступ, который пропадёт после выхода с сервера)
		
		if (c[0] != -1) UpdateClientColorAndNotify(client, c, true);
		//if (bCallAfterAdminAction) ColorMenu(client); // Даём понять, что доступ выдан.
		
		return VGA_Continue;
	}
	
	// У игрока уже есть фактический доступ к функции, но неизвестно включена она у него или нет.
	// Админ пытается включить функцию или изменить текущее значение.
	// Даже если функция отключена, пробуем включить.
	
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
	
	if (c[0] == -1)
		return VGA_BadValue;
	
	if (COLOR_EQUAL(c, g_MyColor[client]))
		return VGA_SameValue;

	UpdateClientColorAndNotify(client, c, true);
	//if (bCallAfterAdminAction) ColorMenu(client); // Даём понять, что доступ изменён.

	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	UpdateClientColorAndNotify(client, {COLOR_DISABLED_VALUE,COLOR_DISABLED_VALUE,COLOR_DISABLED_VALUE,COLOR_DISABLED_VALUE});
}

public OnPluginPauseChange(bool:pause) { if (pause) VIP_TakeAccessAll(); }
public OnPluginEnd() VIP_TakeAccessAll();

static VIP_TakeAccessAll()
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (COLOR_ENABLED(client) && IsClientInGame(client))
			VIP_TakeAccess(client, 0, false);
	}
}

///////////////////////////////////////////////////////////////////////////////////

public OnMapStart() reload();
public VIP_MenuSelect(client, ItemID) ColorMenu(client);

public OnClientSpawn(client, team)
{
	if (COLOR_ENABLED(client))
		CreateTimer(0.1, TIMER_spawn, client, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:TIMER_spawn(Handle:timer, any:client)
{
	if (COLOR_ENABLED(client) && IsClientInGame(client)) SetColor(client, g_MyColor[client]);
	return Plugin_Stop;
}

public OnClientDisconnect_Post(client)
{
	g_MyColorIndex[client] = -1;
	DISABLE_COLOR(client);
}