stock UpdateClientColorAndNotify(client, const color[4], bool:bTryUpdateIndex = false)
{
	g_MyColor[client][0] = color[0];
	g_MyColor[client][1] = color[1];
	g_MyColor[client][2] = color[2];
	g_MyColor[client][3] = color[3];
	
	if (COLOR_ENABLED(client))
	{
		SetColor(client, color);
		
		if (bTryUpdateIndex)
		{
			g_MyColorIndex[client] = -1;
			decl c[4];
			
			for (new index = 0; index < g_Count; index++)
			{
				GetArrayArray(g_hColorAr, index, c, sizeof(c));
				if (COLOR_EQUAL(color, c))
				{
					g_MyColorIndex[client] = index;
					break;
				}
			}
		}
		
		decl String:sRGBA[24];
		COLOR_TO_STRING(g_MyColor[client], sRGBA, sizeof(sRGBA));
		VIP_NotifyItemStatusChanged(client, ITEM_NAME, true, sRGBA, sizeof(sRGBA));
	}
	else
	{
		g_MyColorIndex[client] = -1;
		SetColor(client, {255,255,255,255});
		VIP_NotifyItemStatusChanged(client, ITEM_NAME, false);
	}
}

stock bool:GetColorFromString(const String:str[], color[], const color_size)
{
	if (!str[0] || (color_size != 3 && color_size != 4)) // ток 3 или 4
		return false;
	
	decl String:s[128], i;
	strcopy(s, sizeof(s), str);
	
	if ((i = TrimString(s)) < (color_size == 4 ? 7 : 5)) // "1 3 5" или "1 3 5 7"
		return false;
	
	decl c[color_size];
	new bool:bFoundFirstNumber = false; // "xxx xxx xxx xx1" 1 было найдено
	new c_size = color_size;
	
	while (i--)
	{
		if (bFoundFirstNumber)
		{
			if (IsCharSpace(s[i]))
			{
				c[--c_size] = StringToInt(s[i]);
				bFoundFirstNumber = false;
				s[i] = 0;
				
				if (c_size == 0)
				{
					if (TrimString(s)) // Все числа получили, но там дальше ещё есть что-то, кроме пробелов.
						return false;
					break;
				}
			}
			else if (IsCharNumeric(s[i]))
			{
				if (i == 0)
				{
					c[--c_size] = StringToInt(s[i]);
					break;
				}
			}
			else
				return false;
		}
		else if (IsCharNumeric(s[i]))
		{
			if (i == 0)
			{
				c[--c_size] = StringToInt(s[i]);
				break;
			}
			bFoundFirstNumber = true;
		}
		else if (!IsCharSpace(s[i]))
			return false;
	}
	
	if (c_size == 0 && c[0] > -1 && c[0] < 256 && c[1] > -1 && c[1] < 256 && c[2] > -1 && c[2] < 256 && (color_size == 3 || (c[3] > -1 && c[3] < 256)))
	{
		color[0] = c[0];
		color[1] = c[1];
		color[2] = c[2];
		if (color_size == 4) color[3] = c[3];
		return true;
	}
	
	return false;
}

stock SetColor(entity, const color[4])
{
	SetEntityRenderMode (entity, RENDER_TRANSCOLOR);
	SetEntityRenderColor(entity, color[0], color[1], color[2], color[3]);
}