stock ColorMenu(client, item = 0)
{
	decl String:sText[64];
	
	new Handle:menu = CreateMenu(ColorMenu_CallBack);
	if (COLOR_ENABLED(client))
	{
		COLOR_TO_STRING(g_MyColor[client], sText, sizeof(sText));
		SetMenuTitle(menu, "%T\n \n", "title enabled", client, sText);
	}
	else
		SetMenuTitle(menu, "%T\n \n", "title", client);
	
	decl String:group[GROUP_LENGTH];
	if (!VIP_GetGroupName(client, group, sizeof(group))) group[0] = 0;
	SetMenuExitBackButton(menu, true);
	
	FormatEx(sText, sizeof(sText), "%T", "disable", client);
	AddMenuItem(menu, "disable", sText, COLOR_ENABLED(client) ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);

	decl String:sColorName[COLOR_NAME_LENGTH], Handle:hGroupTrie;
	sColorName[0] = 0;
	
	for (new i = 0; i < g_Count; i++)
	{
		if (!(hGroupTrie = Handle:GetArrayCell(g_hGroupAr, i)) || (group[0] && GetTrieValue(hGroupTrie, group, hGroupTrie)))
		{
			GetArrayString(g_hNameAr, i, sColorName, COLOR_NAME_LENGTH);
			FormatEx(sText, sizeof(sText), "%T", sColorName, client);
			IntToString(i, sColorName, COLOR_NAME_LENGTH);
			AddMenuItem(menu, sColorName, sText, i == g_MyColorIndex[client] ? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT);
		}
	}
	
	if (!sColorName[0])
	{
		FormatEx(sText, sizeof(sText), "%T", "colors not found", client);
		AddMenuItem(menu, "", sText, ITEMDRAW_DISABLED);
	}
	
	DisplayMenuAtItem(menu, client, item, 0);
}

public ColorMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && !VIP_MenuFlood(client))
		VIP_ShowMenu(client);

	else if (action == MenuAction_Select && !VIP_MenuFlood(client))
	{
		new bool:bAccessByFlag;
		if (!VIP_HaveAccessToItem(client, g_ItemID, bAccessByFlag)) // Пока копался в менюшках, потерял права.
		{
			VIP_ShowMenu(client);
			return;
		}
		
		decl String:sInfo[24];
		if (!GetMenuItem(menu, item, sInfo, sizeof(sInfo)))
			return;

		if (!strcmp(sInfo, "disable", false))
		{
			if (COLOR_ENABLED(client))
			{
				SetNewValueInCache(client, "", bAccessByFlag);
				UpdateClientColorAndNotify(client, {COLOR_DISABLED_VALUE,COLOR_DISABLED_VALUE,COLOR_DISABLED_VALUE,COLOR_DISABLED_VALUE});
			}
		}
		else
		{
			new index = StringToInt(sInfo);
			if (g_MyColorIndex[client] != index)
			{
				g_MyColorIndex[client] = index;
				
				decl String:sColorName[COLOR_NAME_LENGTH];
				GetArrayString(g_hNameAr, index, sColorName, COLOR_NAME_LENGTH);
				SetNewValueInCache(client, sColorName, bAccessByFlag);
				
				decl c[4];
				GetArrayArray(g_hColorAr, index, c, sizeof(c));
				UpdateClientColorAndNotify(client, c);
			}
		}
		
		ColorMenu(client, GetMenuSelectionPosition());
	}
}

static SetNewValueInCache(client, const String:sValue[], bool:bAccessByFlag)
{
	if (bAccessByFlag || VIP_GetFlags(client) & VCF_VIP) // обычным игрокам кэш не обновляем
	{
		new Handle:kv = VIP_GetClientCache(client);
		if (kv)
		{
			KvSetString(kv, ITEM_NAME, sValue);
			VIP_SaveClientCache(client, false);
		}
	}
}